# -*- coding: utf-8 -*-
"""Марковский процесс.ipynb

Automatically generated by Colab.

Original file is located at
    https://colab.research.google.com/drive/1HLRKrPWNgsd01LRsfcdqEwv1WNBaj-Uh

### Загрузим файл содержащий в себе временные данные изменения темпа роста и относительной медийной активности Вашего бренда
"""

import pandas as pd

# Создание DataFrame из предоставленных данных

df = pd.read_excel('/content/медиа2.xlsx')

"""### Очистим пропуски при их возможном наличии и проведем нормализацию и стандартизацию имеющегося набора данных"""

import scipy.stats as stats
import numpy as np

z = np.abs(stats.zscore(df))
df = df[(z<3).all(axis=1)]
df.shape

"""### Распределим имеющиеся данные на три группы с помощью выбранных уровней квартилей. Получим разбиение на дни с высоким уровнем показателей, средним и низким."""

import pandas as pd

#  Определение квантилей для используемых параметров (например, 3 квантиля для 3 уровней)
tr_quantiles = df['temp_rost'].quantile([0.4, 0.66])
media_quantiles = df['media_act'].quantile([0.4, 0.66])

# Функция для присвоения категорий на основе квантилей
def assign_category(row):
    if row['temp_rost'] <= tr_quantiles[0.4] and row['media_act'] <= media_quantiles[0.4]:
        return 'Низкий уровень'
    elif row['temp_rost'] >= tr_quantiles[0.66] and row['media_act'] >= media_quantiles[0.66]:
        return 'Высокий уровень'
    else:
        return 'Средний уровень'

# Присвоение категорий каждой строке
df['Уровень'] = df.apply(assign_category, axis=1)

# Вычисление средних значений медиа-влияния и темпа роста для каждого кластера
res = df.groupby('Уровень')[['temp_rost',	'media_act']].mean()

# Добавление информации о количестве элементов в каждом кластере
res['Количество'] = df.groupby('Уровень').size().values

# Вывод результатов
print(res)

"""### Оценим вероятности перехода в другую категорию на следующем временном отрезке."""

# Присвоение категорий каждой строке
df['Уровень'] = df.apply(assign_category, axis=1)

# Создание новой колонки для состояний на основе категорий
df['Состояние'] = df['Уровень']

# Создание матрицы вероятностей переходов
transition_matrix = pd.crosstab(df['Состояние'].shift(-1), df['Состояние'], normalize='index')

# Заполнение NaN значений нулями
transition_matrix = transition_matrix.fillna(0)

print("Матрица вероятностей переходов:")
print(transition_matrix)

"""### Проверим работу алгоритма при увеличении медиа-влияния компании на 10%. Оценим обновившиеся показатели матрицы переходов. Оценим текущее состоянии компании в "уровнях" и предскажем следующее значение."""

# Функция для увеличения медиа-влияния на заданный процент
def increase_media(investment_df, percentage):
    investment_df['media_act'] = investment_df['media_act'] * (1 + percentage / 100)
    return investment_df

# Моделирование увеличения медиа-влияния на 10%
increase_media_df = increase_media(df.copy(), 10)

# Присваивание категорий каждой строке после увеличения медиа-влияния
increase_media_df['Уровень'] = increase_media_df.apply(assign_category, axis=1)

# Создание новой матрицы вероятностей переходов после увеличения медиа-влияния
transition_matrix_increased_media = pd.crosstab(increase_media_df['Уровень'].shift(-1), increase_media_df['Уровень'], normalize='index')

# Заполнение NaN значений нулями
transition_matrix_increased_media = transition_matrix_increased_media.fillna(0)

print("Матрица вероятностей переходов после увеличения медиа-влияния на 10%:")
print(transition_matrix_increased_media)

import numpy as np

# Функция для прогнозирования следующего состояния на основе текущего и матрицы вероятностей переходов
def forecast_next_state(current_state, transition_matrix):
    next_state_prob = transition_matrix.loc[current_state]
    next_state = np.random.choice(next_state_prob.index, p=next_state_prob.values)
    return next_state

# Определение текущего состояния (взять последнюю строку из увеличенного инвестициями DataFrame)
current_state = increase_media_df['Уровень'].iloc[-1]

# Прогнозирование следующего состояния компании на основе матрицы вероятностей переходов
next_state = forecast_next_state(current_state, transition_matrix_increased_media)

print("Текущее состояние компании:", current_state)
print("Прогноз следующего состояния компании:", next_state)

import numpy as np

# Отображение категориальных значений в числовые значения для столбца 'Состояние'
state_mapping = {'Низкий уровень': 0, 'Средний уровень': 1, 'Высокий уровень': 2}
df['Numerical_State'] = df['Состояние'].map(state_mapping)

# Определение матрицы переходов для марковского процесса второго порядка
transition_matrix_2nd_order = np.zeros((3, 3, 3))

# Создание последовательности числовых состояний
sequence = df['Numerical_State'].values

# Заполняем матрицу переходов
for i in range(2, len(sequence)):
    prev_state1 = sequence[i - 2]
    prev_state2 = sequence[i - 1]
    next_state = sequence[i]
    transition_matrix_2nd_order[prev_state1, prev_state2, next_state] += 1

# Нормализация строк матрицы для обеспечения суммирования вероятностей к 1
transition_matrix_2nd_order = transition_matrix_2nd_order / transition_matrix_2nd_order.sum(axis=2, keepdims=True)

# Отображение матрицы переходов
print("Матрица переходов второго порядка:")
print(transition_matrix_2nd_order)

"""### Используем модель случайного леса, наложенную на полученные результаты для предсказания следующего состояния "уровня" компании"""

import pandas as pd
from sklearn.ensemble import RandomForestClassifier
from sklearn.model_selection import train_test_split
from sklearn.metrics import accuracy_score
from sklearn.metrics import mean_absolute_percentage_error

# Подготовка данных для обучения модели
X = df[['temp_rost', 'media_act']]
y = df['Состояние']

# Разделение данных на обучающий и тестовый набор
X_train, X_test, y_train, y_test = train_test_split(X, y, test_size=0.4, random_state=0)

# Обучение случайного леса
rf = RandomForestClassifier()
rf.fit(X_train, y_train)

# Прогнозирование состояний на тестовом наборе
y_pred = rf.predict(X_test)

# Оценка точности модели
accuracy = accuracy_score(y_test, y_pred)
print("Accuracy:", accuracy)

# Вывод результатов модели на тестовом наборе данных
results = pd.DataFrame({
    'media_act': X_test['media_act'],
    'temp_rost': X_test['temp_rost'],
    'Состояние': y_test,
    'Pred_Состояние': y_pred
})

print("Результаты модели на тестовом наборе данных:")
print(results)

# Оценка важности признаков для модели
feature_importances = pd.DataFrame({
    'Feature': X.columns,
    'Importance': rf.feature_importances_
})

print("\nВажность признаков для модели случайного леса:")
print(feature_importances)

"""### Реальное применение на данных пользователя вводимых позднее

"""

import pandas as pd

n=2
t_rost=[]
med_act=[]


for i in range (n):  # Проходимся по каждой букве в слове
# Запрашиваем у пользователя данные для первой переменной
  t_r = float(input("Введите значение для темпа росто: "))
# Запрашиваем у пользователя данные для второй переменной
  m_act = float(input("Введите значение для media_act: "))
  t_rost.append(t_r)
  med_act.append(m_act)

print(med_act)
print(t_rost)
df = pd.DataFrame(data={'temp_rost':t_rost , 'media_act': med_act})
# Выводим получившийся DataFrame
print(df)


new_predictions = rf.predict(df)
print("\nПредсказания модели для новых данных:")
print(new_predictions)

# Пример предсказания для новых данных
new_data = pd.DataFrame({
    'temp_rost': [180.5, 120.0],
    'media_act': [0.6, 0.003]
})

new_predictions = rf.predict(new_data)
print("\nПредсказания модели для новых данных:")
print(new_predictions)